MOUNT_NFS(8)

NAME
mount_nfs - mount NFS file systems

SYNOPSIS
mount_nfs [-23bcdilsTU] [-a maxreadahead] [-g maxgroups] [-I readdirsize] [-o options] [-R retrycnt] [-r readsize] [-t timeout] [-w writesize] [-x retrans] rhost:path node

DESCRIPTION
The mount_nfs command calls the mount(2) system call to prepare and graft a remote NFS file system (rhost:path) on to the file system tree at the point node. This command is normally executed by mount(8). It implements the mount protocol as described in RFC 1094, Appendix A and Appendix I.

The options are as follows:

-2  Use the NFS Version 2 protocol.

-3  Use the NFS Version 3 protocol. The default is to try version 3 first, and fall back to version 2 if the mount fails.

-a maxreadahead
    Set the read-ahead count to the specified value. This may be in the range of 0-4, and determines how many blocks will be read ahead when a large file is being read sequentially. Trying a value greater than 1 for this is suggested for mounts with a large bandwidth-delay product.

-b  If an initial attempt to contact the server fails, fork off a child to keep trying the mount in the background. Useful for fstab(5), where the file system mount is not critical to multiuser operation.

-c  For UDP mount points, do not do a connect(2). This must be used for servers that do not reply to requests from the standard NFS port number 2049. It may also be required for servers with more than one IP address (only necessary if replies come from an address other than the one specified in the mount request).

-d  Turn off the dynamic retransmit timeout estimator. This may be useful for UDP mounts that exhibit high retry rates, since it is possible that the dynamically estimated timeout interval is too short.

-g maxgroups
    Set the maximum size of the group list for the credentials to the specified value. This should be used for mounts on old servers that cannot handle a group list size of 16, as specified in RFC 1057. Try 8, if users in a lot of groups cannot get a response from the mount point.

-I readdirsize
    Set the readdir read size to the specified value. The value should normally be a multiple of DIRBLKSIZ that is less than or equal to the read size for the mount.

-i  Make the mount interruptible, which implies that file system calls that are delayed due to an unresponsive server will fail with EINTR when a termination signal is posted for the process.

-l  Used with NFSV3 to specify that the “readdir plus” RPC should be used. This option reduces RPC traffic for cases such as “ls -l”, but tends to flood the attribute and name caches with prefetched entries. Try this option and see whether performance improves or degrades. Probably most useful for client to server network interconnects with a large bandwidth-delay product.

-o options
    Options are specified with a -o flag followed by a comma separated string of options. The prefix “no” may be added to invert the behavior of default options that do not take arguments. See the mount(8) man page for possible options and their meanings.

    The following NFS specific options are also available:

    ac  Enable attribute caching for both files and directories (default).

    acdirmax=num
        Cache directory attributes for no more than num seconds. The default is 60 seconds.

    acdirmin=num
        Cache directory attributes for at least num seconds. The default is 5 seconds.

    acregmax=num
        Cache file attributes for no more than num seconds. The default is 60 seconds.

    acregmin=num
        Cache file attributes for at least num seconds. The default is 5 seconds.

    port=portnumber
        Use the specified port number for NFS requests. The default is to query the portmapper for the NFS port.

-R retrycnt
    Set the retry count for doing the mount to the specified value. The default is 10000.

-r readsize
    Set the read data size to the specified value. It should normally be a power of 2 greater than or equal to 1024. This should be used for UDP mounts when the “fragments dropped after timeout” value is getting large while actively using a mount point. (Use netstat(1) with the -s option to see what this value is.) See the -w option as well.

-s  A soft mount, which implies that file system calls will fail after retrans round trip timeout intervals have been reached (see -x).

-T  Use TCP instead of UDP. Note that TCP may not be supported by some very old NFS servers.

-t timeout
    Set the initial retransmit timeout to the specified value in milliseconds. May be useful for fine tuning UDP mounts over internetworks with high packet loss rates or an overloaded server. Try increasing the interval if nfsstat(1) shows high retransmit rates while the file system is active or reducing the value if there is a low retransmit rate but long response delay observed. (Normally, the -d option should be specified when using this option to manually tune the timeout interval.)

-U  Force the mount protocol to use UDP, even for TCP NFS mounts. (Necessary for some old BSD servers.)

-w writesize
    Set the write data size to the specified value. Ditto the comments w.r.t. the -r option, but using the “fragments dropped after timeout” value on the server instead of the client. Note that both the -r and -w options should only be used as a last ditch effort at improving performance when mounting servers that do not support TCP mounts.

-x retrans
    Set the retransmit timeout count for soft mounts to the specified value. Defaults to 10.

In versions prior to OpenBSD 2.7, nfsiod servicios were running to improve performance of client NFS I/O. This is no longer done this way. Use sysctl(8) or modify sysctl.conf(5) to adjust the vfs.nfs.iothreads value, which is the number of kernel threads created to serve asynchronous NFS I/O requests.

SEE ALSO
nfsstat(1), mount(2), tcp(4), udp(4), fstab(5), mount(8), nfsd(8), showmount(8), sysctl(8), umount(8)

HISTORY
The -P flag historically informed the kernel to use a reserved port when communicating with clients. In OpenBSD, a reserved port is always used.

BUGS
Due to the way that Sun RPC is implemented on top of UDP (unreliable datagram), tuning such mounts is really a black art that can only be expected to have limited success.